package cn.ischoolcode.javabook.scene9;

/* 
 * 爱校码
 * http://www.ischoolcode.cn/
 *  
 * @author zcj
 */
import java.util.*;
class Colors {
	 private String colorName;
	 public Colors(String color) {
		colorName = color;
	 }
	 public String getColorName() {
		return colorName;
	 }
     public int hashCode() {
		return colorName.hashCode();
	 }
	 public boolean equals(Object o) {
		Colors col = (Colors) o;
		return (colorName.equals(col.colorName));
	 }
	 public String toString() {
		return ("{" + colorName + "}");
	 }
}
class ColorNameComparator implements Comparator<Colors> {
	 public int compare(Colors col1, Colors col2) {
		String colorName1 = col1.getColorName().toUpperCase();
		String colorName2 = col2.getColorName().toUpperCase();
		return colorName1.compareTo(colorName2);
	 }
}
public class CollectionsTest {
	 public static void main(String[] args) {
		double array[] = { 112, 111, 23, 456, 231, 21.2, 0.1 };
		List<Double> dList = new ArrayList<Double>();
		for (Double d : array)
			dList.add(d);
		Colors col1 = new Colors("red");
		Colors col2 = new Colors("blue");
		Colors col3 = new Colors("yellow");
		Colors col4 = new Colors("orange");
		List<Colors> cList = new ArrayList<Colors>();
		cList.add(col1);
		cList.add(col2);
		cList.add(col3);
		cList.add(col4);
		System.out.println("===Sort===");
		Collections.sort(dList);
		System.out.println(dList);
        Comparator comparator=new ColorNameComparator();
		Collections.sort(cList, comparator);
		System.out.println(cList);
		System.out.println("===binarySearch===");
	    System.out.println(Collections.binarySearch(cList,new 
                                    Colors("orange"),comparator));
		Collections.sort(cList, new ColorNameComparator());
		System.out.println(cList);
		System.out.println("===Reverse===");
		Collections.reverse(dList);
		System.out.println(dList);
		System.out.println("===Shuffle===");
		Collections.shuffle(dList);
		System.out.println(dList);
		System.out.println("===Fill===");
		Collections.fill(dList, 0.0);
		System.out.println(dList);
		System.out.println("===Copy===");
		List<Double> copyList = new ArrayList<Double>();
		for (Double d : array)
			copyList.add(d);
		Collections.copy(dList, copyList);
		System.out.println(dList);
		System.out.println("===Min&Max===");
		System.out.println("min=" + Collections.min(dList) + " max="
				+ Collections.max(dList));
		System.out.println("min="
				+ Collections.min(cList, new ColorNameComparator()) + " max="
				+ Collections.max(cList, new ColorNameComparator()));
		System.out.println("===IndexOfSubList&lastIndexOfSubList===");
		System.out.println(Collections.indexOfSubList(dList, copyList));
		System.out.println(Collections.lastIndexOfSubList(dList, copyList));
		System.out.println("===Rotate===");
		Collections.rotate(dList, 1);
		System.out.println(dList);
		Collections.rotate(dList, -1);
		System.out.println(dList);
		System.out.println("===nCopies===");
 		dList.addAll(Collections.nCopies(3, 0.9));
 		System.out.println(dList);
 		System.out.println("===swqp===");
 	    Collections.swap(dList, 0, 1);
 		System.out.println(dList);
 		System.out.println("===disjoint===");
 		System.out.println(Collections.disjoint(dList, copyList));
 		System.out.println("===frequency===");
 		System.out.println(Collections.frequency(dList, 0.9));
 	}
}